---
title: Programming in C
subtitle: Dynamic Memory Management
layout: layouts/presentation.njk
requires: pointers, structs
---

<section>
  <h2>Purpose of Dynamic Memory Management</h2>

  <section>
  <h3>Which problems does this solve?</h3>
  <ul>
    <li>Allows to dynamically allocate memory, and free it for reuse afterwards</li>
    <li>Permits returning (pointers to) arrays from functions</li>
    <li>Only way for non-C99 compilers to set array size at runtime</li>
    <li>Can grow and shrink dynamic data structures (linked lists, trees, ...)</li>
    <li class="fragment">Required for using memory from the heap (free store)</li>
    <li class="fragment">Large amounts of memory can only be used from the heap</li>
  </ul>
  <p class="fragment">The size of the stack can be determined with <code>ulimit -s</code></p>
  </section>

  <section>
  <h3>Which problems might this cause?</h3>
  <ul>
    <li>Requires working with pointers</li>
    <li>Relatively slower compared to the stack</li>
    <li>Programmer in charge of managing memory</li>
    <li class="fragment">Potential memory leaks (tools like valgrind help with debugging)</li>
  </ul>

  <div class="fragment">
    Some of these problems are (partly) solved by C++ and higher level languages
  </div>
  </section>
</section>

<section>
  <h2>C API</h2>
  <dl>
    <dt><code>#include &lt;stdlib.h&gt;</code></dt>
    <dt><code>void *malloc(size_t size)</code></dt>
    <dd>Allocates <code>size</code> bytes and returns a pointer to the
      allocated memory.  The memory is not initialized.</dd>
    <dt><code>void free(void *ptr)</code></dt>
    <dd>Frees the memory space pointed to by <code>ptr</code>.</dd>
  </dl>
  <dl class="fragment">
    <dt><code>void *calloc(size_t nmemb, size_t size)</code></dt>
    <dd>Allocates memory for an array of <code>nmemb</code> elements of
      <code>size</code> bytes each and returns a
      pointer to the allocated memory.  The memory is set to zero.</dd>
    <dt><code>void *realloc(void *ptr, size_t size)</code></dt>
    <dd>Changes the size of the memory block pointed to by ptr to size bytes.</dd>
    <dt><code>void *reallocarray(void *ptr, size_t nmemb, size_t size);</code></dt>
    <dd>Changes the size of the memory block pointed to by ptr to be large
      enough for an array of <code>nmemb</code> elements, each of which is
      <code>size</code> bytes.</dd>
  </dl>
</section>

<section>
  <h2>Working with the Heap</h2>
  <section>
    <h3>Determine array size at runtime</h3>
{% highlight "c 1" %}
const int size = 1234;  // any value determined at runtime
int array[size];
{% endhighlight %}

<div class="fragment">
    <p>Unfortunately, the above only works for C99 capable compilers</p>
{% highlight "c 1,3" %}
const int size = 1234;  // any value determined at runtime
int* array = malloc(size * sizeof(int));
// use the array ...
free(array);
{% endhighlight %}
</div>

<div class="fragment">
    <p>Alternatively, one can be more explicit with a typecast</p>
{% highlight "c 1,3" %}
const int size = 1234;  // any value determined at runtime
int* array = (int*) malloc(size * sizeof(int));
// use the array ...
free(array);
{% endhighlight %}
</div>
  </section>

  <section>
    <h3>Make Sure the Calls Were Successful</h3>
{% highlight "c 2" %}
const size_t size = 1234;  // any value determined at runtime
int* array = (int*) malloc(size * sizeof(int));
if (array == NULL) {  // NULL pointer means no memory was allocated
  fprintf(stderr, "malloc %lu bytes failed\n", size);
  exit(EXIT_FAILURE);
}
// use the array ...
free(array);
{% endhighlight %}
  </section>

  <section>
    <h3>Limited Size of the Stack</h3>
    <p>Determine the size of the stack via</p>
{% highlight "bash" %}
$ ulimit -s  # or `ulimit -a` for all limits
{% endhighlight %}
    <p>Impossible to exceed the given stack size</p>
{% highlight "c 2" %}
{% include "source/c/free_store/exceed_stack_size.c" %}
{% endhighlight %}
    <p>Try to compile and run
      <a href="/data/c/free_store/exceed_stack_size.c">exceed_stack_size.c</a>
    </p>
    <p class="fragment">If large amount of memory is needed, one has to use
      the heap...</p>
  </section>
</section>

  <section>
  <h2>Examples</h2>

  <section>
    <h3>Allocate Memory for an Array</h3>
{% highlight "c 4,12" %}
{% include "source/c/free_store/allocate_array.c" %}
{% endhighlight %}
{% include_code "source/c/free_store/allocate_array.c" %}
  </section>

  <section>
    <h3>Allocate Large Amount of Memory</h3>
{% highlight "c 4,5,14" %}
{% include "source/c/free_store/allocate_large_array.c" %}
{% endhighlight %}
{# crashes the tutor, hence a normal download link #}
<p>{% download "/data/c/free_store/allocate_large_array.c" %}<p>
  </section>

  <section>
    <h3>Return Array of Structs</h3>
{% highlight "c 6,9,13,19" %}
{% include "source/c/free_store/return_array_of_structs.c" %}
{% endhighlight %}
{% include_code "source/c/free_store/return_array_of_structs.c" %}
  </section>

</section>

{% include 'slides/closing.njk' %}
